/*
 * PHP-GTK - The PHP language bindings for GTK+
 *
 * Copyright (C) 2001,2002 Andrei Zmievski <andrei@php.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
/* $Id: php_piemenu.c,v 1.2 2002/04/11 02:19:47 andrei Exp $ */

#include "php_piemenu.h"

#if HAVE_PIEMENU

#ifdef PHP_GTK_COMPILE_DL_PIEMENU
PHP_GTK_GET_EXTENSION(piemenu)
#endif

PHP_GTK_XINIT_FUNCTION(piemenu)
{
	php_piemenu_register_constants(module_number TSRMLS_CC);
	php_piemenu_register_classes();

	return SUCCESS;
}

php_gtk_ext_entry piemenu_ext_entry = {
	"piemenu",
	PHP_GTK_XINIT(piemenu),
	NULL,
};

#endif	/* HAVE_PIEMENU */
