<?php

/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
	Class AddressBookConfig {
		var $uid;
		var $type;
		var $name;
		var $location;
		var $username;
		var $password;
		var $db;
		var $conn;
		
		function AddressBookConfig($uid,$type, $name, $loc, $user, $pass, $db) {
			$this->uid=$uid;
			$this->type=$type;
			$this->name=$name;
			$this->location=$loc;
			$this->username=$user;
			$this->password=$pass;
			$this->db=$db;
			$this->conn=$conn;
		}
		
		function get_uid() {
			return $this->uid;
		}

		function get_location() {
			return $this->location;
		}
	
		function get_name() {
			return $this->name;
		}

		function get_type() {
			return $this->type;
		}
		function get_conn() {
			return $this->conn;
		}

/* ###################################################################################################################
	Save this object to the given filename
################################################################################################################### */ 
	function save_new ($filename) {
		$write_string=$this->uid.",".$this->type.",".$this->name.",".$this->location.",".$this->username.",".$this->password.",".$this->db."\n";
		
		// If the type is db then we need to go and create a table for it
		if ($this->type == "db") {
			//Add the table to the database
			
			if ($this->password == "null") 
				$link = mysql_connect($this->location,"$this->username");
			
			//FIXME untested code!
			else 
				$link = mysql_connect($this->location,$this->username,$this->password);
			
			// We should now have a valid DB entry, we need to create the table
			$query="CREATE TABLE $this->name (indx int(11) NOT NULL auto_increment,
				fname varchar(50) NOT NULL,   
				mname varchar(50),   
				lname varchar(50) NOT NULL,   
				phone varchar(30),   
				email varchar(50) NOT NULL,   
				insdate datetime DEFAULT '0000-00-00 00:00:00' NOT NULL, 
				PRIMARY KEY (indx),UNIQUE indx (indx),   KEY indx_2 (indx))";
			$success=mysql_db_query("$this->db","$query",$link);
		
			//Here's where we catch all the problems
			if ($success != TRUE) {
				$message = "An error occured trying to create a new table on $this->location.\n The error message is:\n".mysql_error();
				mysql_close($link);
				return $message;
			}
			mysql_close($link);
		}
		elseif ($this->type == tfile) {
		// This just creates an empty file
			$fp = fopen($this->location,"w");
			fclose($fp);
		}
		
		
		$fp = fopen ($filename,"a");
		$success=fputs($fp,$write_string);
		fclose($fp);
		if (!$success)
			return("An error occured saving this entry\n to the configuration file $filename.");
		else
			return (TRUE);
	}
	
/* ###################################################################################################################
	Remove this entry from the config file
################################################################################################################### */ 
	function  delete_address_book ($filename) { 
		
		//First thing we do is make a copy incase something goes wrong
		$file_copy = $filename.".bak";
		$copy_success = copy ($filename,$file_copy);
		if ($copy_success != TRUE) {
			echo "Couldn't make file copy \n";
			return;
		}
		chmod ($file_copy,0600);
		
		$fp_old = fopen ($file_copy,"r");
		$fp_new = fopen ($filename,"w");
		
		while (!feof ($fp_old)) {
			$buffer = fgets($fp_old,4096);
			if (($buffer[0] == "#") || (strncmp($buffer, $this->uid,14) != 0))
				fwrite($fp_new,$buffer);
		}
		
		
		fclose($fp_old);
		fclose($fp_new);
		
		
	}
	
/* ###################################################################################################################
	Change an entry in the given config file
################################################################################################################### */ 
	function  change_address_book ($filename) { 	
	
	$write_string=$this->uid.",".$this->type.",".$this->name.",".$this->location.",".$this->username.",".$this->password.",".$this->db."\n";
		
	//First thing we do is make a copy incase something goes wrong
		$file_copy = $filename.".bak";
		$copy_success = copy ($filename,$file_copy);
		if ($copy_success != TRUE) {
			return "Unable to copy configuration file.\n Make sure you have permission to\n write to the config directory.";
		}
		$fp_old = fopen ($file_copy,"r");
		$fp_new = fopen ($filename,"w");
		
		while (!feof ($fp_old)) {
			$buffer = fgets($fp_old,4096);
			if (($buffer[0] != "#") && (strncmp($buffer, $this->uid,14) == 0)) 
				fwrite($fp_new,$write_string);
			else 
				fwrite ($fp_new,$buffer);
				
		}
		fclose($fp_old);
		fclose($fp_new);
		
		// Assume it all went well! Needs a little more I think
		return TRUE;
		
		
	}
}
?>
