<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/* This is a Clist widget that known how to handle a inserting a AdbEntryClass 
	10-30-2001
		- Fixed creation (I have no idea how it actually worked before this)
		- Added sort function

*/

Class TeakAddressCList extends GtkCList {
	function TeakAddressCList($num_cols,$column_titles) {
		$this->GtkCList($num_cols,$column_titles);
		$this->connect('click_column',array(&$this, sort_clist));
}
	

/* ########################################################################################################
	Function to take an entry class and add it's values into the clist
*/ ########################################################################################################
	function insert_entry_class ($entry_class) {
		$name=$entry_class->get_first_name()." ".$entry_class->get_middle_initial()." ".$entry_class->get_last_name();
		$this->append(array($name,$entry_class->get_mail(), $entry_class->get_phone(), $entry_class->get_uid()));
	}

/* ########################################################################################################
	Function to sort the entries
*/ ########################################################################################################
	function sort_clist ($clist, $column) {
		if ($column == $clist->sort_column) {
                        if ($clist->sort_type == GTK_SORT_DESCENDING)
                                $clist->set_sort_type(GTK_SORT_ASCENDING);
                        else
                                $clist->set_sort_type(GTK_SORT_DESCENDING);  
		} 
		else
                        $clist->set_sort_column($column);
			
		$clist->sort();
	}
}
