<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	Class error_dialog extends GtkDialog {
		function error_dialog($message) {
			$this->GtkDialog();
			$this->realize();

			$this->set_title("Something has gone wrong!");
			$this->set_border_width(10);
			$top_box=$this->vbox;
			$bottom_box=$this->action_area;


			$message_label = &new GtkLabel($message);
			$close_button = &new PictureButton("Close","images/stock_close.xpm",$this,HORZ,"Close This Window");
			$close_button->connect('clicked',array($this,destroy_dialog),$this);

			$top_box->add($message_label);
			$bottom_box->add($close_button);

			$this->set_modal(TRUE);			
			$this->show_all();
	}

/* #################################################################################################
	destroy the message dialog
*/ #################################################################################################
	function destroy_dialog($widget, $dialog) {
		$dialog->destroy();
	}

}
