<?php

/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

Class password_dialog extends GtkDialog {
	var $ok_button;
	var $passwd_entry;
	var $cancel_button;
	function password_dialog($current_server) {
		
		$this->GtkDialog();
		$this->set_modal(TRUE);
		$this->set_title("Enter Password for $current_server[user] on $current_server[host]");
		$this->set_border_width(5);

		$top_box=$this->vbox;
		$bottom_box=$this->action_area;

		$passwd_label = &new GtkLabel("Enter Password for $current_server[user] on $current_server[host]");
		$passwd_entry = &new GtkEntry();
		$this->passwd_entry=$passwd_entry;
		$passwd_entry->set_visibility(FALSE);

		$this->realize();

		$ok_button = &new PictureButton("OK","images/stock_button_ok.xpm",$this,HORZ,"Connect To Mail Server");
		$ok_button->set_name("OK_Button");
		$this->ok_button=$ok_button;
		$ok_button->connect('clicked',array($this,end_main));

		$cancel_button = &new PictureButton("Cancel","images/stock_button_cancel.xpm",$this,HORZ,"Close This Window");
		$this->cancel_button=$cancel_button;
		$cancel_button->connect('clicked',array($this,end_main));

		$top_box->set_spacing(5);
		$top_box->pack_start($passwd_label);
		$top_box->pack_start($passwd_entry);

		$bottom_box->set_spacing(5);
		$bottom_box->pack_start($ok_button);
		$bottom_box->pack_start($cancel_button);

		$this->show_all();
		$passwd_entry->grab_focus();		


	}

	function end_main($widget) {
		Gtk::main_quit();
	}
	
	function start_main() {
		// "Start" the widget
		Gtk::main();
	}

	function get_ok_button() {
		$passwd_OK=$this->ok_button;
		return $passwd_OK;
	}
	
	function get_cancel_button() {
		$passwd_cancel=$this->cancel_button;
		return $passwd_cancel;
	}

	function get_passwd_entry () {
		return $this->passwd_entry;
	}

}
?>
