<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	Class MessageList extends GtkCList {
		function MessageList($columns, $titles) {
			$this->GtkCList($columns, $titles);
			global $config;
			global $servers;
			
			$this->set_name("MessageList");
			$this->set_column_width(0,200);
			$this->set_column_width(1,120);
			$this->set_column_width(2,110);

			/* These columns are special, 4 is the message unique id and 5 is the unix time
				stamp that's used for sorting by date */
			$this->set_column_visibility(4,FALSE);
			$this->set_column_visibility(5,FALSE);
			$this->set_column_visibility(6,FALSE);
		}
		
	}








?>