<?php

/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

Class yes_no_dialog extends GtkDialog {
	var $ok_button;
	var $cancel_button;
	var $user_result;
	function yes_no_dialog($label_text) {

		$this->GtkDialog();
		$this->set_modal(TRUE);
		$this->set_title("Question ?");
		$this->set_border_width(5);
		$this->realize();

		$top_box=$this->vbox;
		$bottom_box=$this->action_area;

		$label = &new GtkLabel($label_text);

		$passwd_OK = &new PictureButton("OK","images/stock_button_yes.xpm",$this,HORZ,"Delete The Selected Folder");
		$passwd_OK->set_name("OK");
		$this->ok_button=$passwd_OK;
		$passwd_OK->connect('clicked',array(&$this, set_result));
				
		$passwd_cancel = &new PictureButton("Cancel","images/stock_button_no.xpm",$this,HORZ,"Close This Window Without Deleting The Folder");
		$passwd_cancel->set_name("Cancel");
		$this->cancel_button=$passwd_cancel;
		$passwd_cancel->connect('clicked',array(&$this, set_result));
		
		$top_box->set_spacing(5);
		$top_box->pack_start($label);

		$bottom_box->set_spacing(5);
		$bottom_box->pack_start($passwd_OK);
		$bottom_box->pack_start($passwd_cancel);

		$this->show_all();


	}

	function end_main() {
		Gtk::main_quit();
	}
	
	function set_result ($widget) {
		if ($widget->get_name() == "OK")
			$this->user_result=TRUE;
		else
			$this->user_result=FALSE;
			
	}
	
	function start_main() {
		// "Start" the widget
		Gtk::main();
	}

	function get_ok_button() {
		$passwd_OK=$this->ok_button;
		return $passwd_OK;
	}
	
	function get_cancel_button() {
		$passwd_cancel=$this->cancel_button;
		return $passwd_cancel;
	}

	function get_result() {
		return $this->user_result;
	}

}
?>
